[![Chai Documentation](http://chaijs.com/public/img/chai-logo.png)](http://chaijs.com)

Chai is a BDD / TDD assertion library for [node](http://nodejs.org) and the browser that
can be delightfully paired with any javascript testing framework.

For more information or to download plugins, view the [documentation](http://chaijs.com).

[![Build Status](https://travis-ci.org/chaijs/chai.svg?branch=master)](https://travis-ci.org/chaijs/chai)

[![Selenium Test Status](https://saucelabs.com/browser-matrix/chaijs.svg)](https://saucelabs.com/u/chaijs)

### Plugins

Chai offers a robust Plugin architecture for extending Chai's assertions and interfaces.

- Need a plugin? View the [official plugin list](http://chaijs.com/plugins).
- Have a plugin and want it listed? Open a Pull Request at [chaijs/chai-docs:plugin.js](https://github.com/chaijs/chai-docs/blob/master/plugins.js#L1-L12).
- Want to build a plugin? Read the [plugin api documentation](http://chaijs.com/guide/plugins/).

### Related Projects

- [chaijs / assertion-error](https://github.com/chaijs/assertion-error): Custom `Error` constructor thrown upon an assertion failing.
- [chaijs / deep-eql](https://github.com/chaijs/deep-eql): Improved deep equality testing for Node.js and the browser.

### Contributors

     project  : chai
     repo age : 3 years, 3 months
     active   : 224 days
     commits  : 859
     files    : 59
     authors  :
       554  Jake Luer           64.5%
        79  Veselin Todorov     9.2%
        43  Domenic Denicola    5.0%
        29  Keith Cirkel        3.4%
        14  Joshua Perry        1.6%
         8  Chris Polis         0.9%
         6  Ian Zamojc          0.7%
         6  Ruben Verborgh      0.7%
         5  Juliusz Gonera      0.6%
         5  George Kats         0.6%
         5  Jo Liss             0.6%
         5  Scott Nonnenberg    0.6%
         5  leider              0.6%
         4  charlierudolph      0.5%
         4  Chris Jones         0.5%
         4  Max Edmands         0.5%
         4  David da Silva      0.5%
         4  Veselin             0.5%
         4  josher19            0.5%
         4  John Firebaugh      0.5%
         4  Nick Heiner         0.5%
         3  Andrei Neculau      0.3%
         3  Duncan Beevers      0.3%
         3  Ryunosuke SATO      0.3%
         3  Jake Rosoman        0.3%
         3  Jason Karns         0.3%
         3  Jeff Barczewski     0.3%
         2  Jakub Nešetřil      0.2%
         2  Teddy Cross         0.2%
         2  Roman Masek         0.2%
         2  Gregg Lind          0.2%
         2  Edwin Shao          0.2%
         2  Bartvds             0.2%
         1  toastynerd          0.1%
         1  Anand Patil         0.1%
         1  Benjamin Horsleben  0.1%
         1  Brandon Payton      0.1%
         1  Chasen Le Hara      0.1%
         1  Chris Connelly      0.1%
         1  Chris Thompson      0.1%
         1  Christopher Hiller  0.1%
         1  Chun-Yi             0.1%
         1  DD                  0.1%
         1  Danilo Vaz          0.1%
         1  Dido Arellano       0.1%
         1  Jeff Welch          0.1%
         1  Jesse McCarthy      0.1%
         1  Julien Wajsberg     0.1%
         1  Kilian Ciuffolo     0.1%
         1  Luís Cardoso        0.1%
         1  Martin Middel       0.1%
         1  Mathias Schreck     0.1%
         1  Michael Lange       0.1%
         1  Niklas Närhinen     0.1%
         1  Paul Miller         0.1%
         1  Refael Ackermann    0.1%
         1  Sasha Koss          0.1%
         1  Victor Costan       0.1%
         1  Vinay Pulim         0.1%
         1  Virginie BARDALES   0.1%
         1  ericdouglas         0.1%
         1  laconbass           0.1%
         1  mohayonao           0.1%
         1  piecioshka          0.1%
         1  shinnn              0.1%
         1  Adam Hull           0.1%


## License

(The MIT License)

Copyright (c) 2011-2015 Jake Luer <jake@alogicalparadox.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
